=========
HISTORY :
=========

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.5.2 - last fixes (**) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Fix path error when link by uid is not used
   http://plone.org/products/fckeditor/issues/68
   http://plone.org/products/fckeditor/issues/69

2. Fix path error when using direct upload (when linkbyuid is not used)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.5.1 - last fixes (**) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------


1. Added the ability to change browser path and browser root
   with a contextual method
   
2. Force FCKeditor when fckwidget is used in a field      

3. Fix fckeditor browser root to the first parent which provides INavigationRoot

4. Added fck_area_css_id and fck_area_css_class attributes in fckwidget
   to be able to get real wysiwyg when editing zones outside of #content (ex #portal-footer or something else)
   
(**) FCKeditor 2.x will be replaced by CKeditor 3.x in near future   

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.5 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Includes FCKeditor 2.6.5 version (see docs/_whatsnew.html)

2. Includes imgmap plugin (http://martinezdelizarrondo.com/imagemaps/) a very good tool

3. If a folder had not the same skin as portal, this skin was not rendered in FCKeditor area
   because the skinname was missing in css urls in getFCKArea_default_style.py
   
4. The default opening folder for upload is no more the Article but the parent when 
   editing PloneArticle content types.
   Fix the 'upload not allowed error' when using the quick upload feature.

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.4.2 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. fix regression when browsing PloneArticle attachments 
   added state='' in xml results for PA proxies

2. upload is no more allowed in articles
   because in Plone3 it becames really complicated to 
   upload contents inside context during edition
   it's impossible when using portal_factory
   it's impossible when using Plone Article edition forms
   MULTIPAGE schema is responsible.
   
3. fix states colors in browser :
   use member.css standard style
   use classes on links, with good class name (state-private, state-published ... )   

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.4.1 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. egg was bad (docs folder was missing)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.4 - last release (**) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Includes FCKeditor 2.6.4 version (see docs/_whatsnew.html)
   FCKeditor.Plone is not impacted by the security issue fixed in 2.6.4.1 (the connector used for browsing files is Plone specific)

2. Merge gotcha branch (review state class added in browser results) - Thanks to Godefroid ;-)

3. modified ConvertToXmlAttribute method to include escaping of less-than and greater-than characters to XML entities - Thanks to Matth

4. rtspellcheck plugin patched (plugin is only loaded when client spellchecker is choosen in configuration)

5. Fix XHTML errors in WSC html pages (new WebSpellChecker added in FCKeditor 2.6.4)

5. include new 2.6.4 SpellChecker options in fckeditor control panel, you can choose 3 options :
   
   * client spellchecker (iespell or firefox standard spellchecker), it's the default option.
   
   * WSC (see WebSpellChecker in fckeditor documentation and www.spellchecker.net)
   
   * Your own speller pages (collective.diy)       

(**) The next releases will be called collective.ckeditor or something else, i don't know.
      

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.3.3 (UNRELEASED) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. We can specify a list of stylesheets paths (relative to portal)
   or stylesheets urls to replace portal_css resources for editor area.
   Useful with Deliverance


------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.3.2 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. reference to old FCKHTTPCache removed in all matadata files
   important fix update your product


------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.3.1 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. fckeditor widget use rich widget macro in view mode to make kss inline edition possible

2. get_fckbasehref hack to get the good base href for fckeditor explorer when context is a portlet :
   this fix XML errors in browser when editing a static portlet (http://trac.ingeniweb.com/ticket/77)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.3 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Includes FCKeditor 2.6.3 version (see docs/_whatsnew.html > many bugfixes)

2. connector  : accept Media Resource Type upload 
   TODO : portal_type for Media upload
   
3. FckHTTPCache installation is removed (using CacheFu give your a better control on SQUID, so let's go)   

4. Use standard resolveuid redirection (the old script + safehtml rule is always here for old links)

5. fix small error in base2zope.py (about window was broken)

6. fckruid safehtml method change all resolveuid patterns (no more case sensitive)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.2 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Includes FCKeditor 2.6.2 version (see docs/_whatsnew.html)
2. Includes flvPlayer plugin
3. Changes in connectorPlone, fckconfig.js, fck_plone.js to play with FCKConfig.MediaBrowser options (used by flvPlayer)
4. base2zope changed : now includes htc files in skin as htc.pt
5. Remove resolveUid links for Medias insertion (redirection do not work with mediaplayer.swf)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6.1 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Images explorer : same behavior for all browsers (nb of images by row in album view depends on browser innerWidth)
2. Images explorer : same behavior for PloneArticleV4 Images and standard Plone images (same sizes)
3. fix bug http://trac.ingeniweb.com/ticket/65  (flash insertion was broken)
4. setup.py changed (name was bad)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.6 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Trunk moved to Products.FCKeditor/trunk to make an FCKeditor.Plone basic egg
   http://trac.ingeniweb.com/ticket/55 in progress ...
2. FCKEditor 2.6 integration :
   close ticket : http://trac.ingeniweb.com/ticket/54


------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.8 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. added fckeditor-plone-en.po for some labels
2. fix http://plone.org/products/fckeditor/issues/44, 
   resolve problems with innerHTML method on FireFox, 
   avoid marked links in Plone2.5 editor area.
3. fix link widget alert with unload protection
   fix folder path (just parent path)
4. Make sure anonymous editors (for example someone adding a response in
   Poi) do not get this error message but get the default simple textarea
   instead:
   "not installed correctly: Path element may not be empty in 'here//wysiwyg_support'   "
   Thx to maurits :-)
5. Don't let height be under 400px   
6. Fix bug http://plone.org/products/fckeditor/issues/56 on editor area css
   when fontBaseSize is not in "%""
   
  

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.7 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Disable unload protection when saving entire form with the save icon
  (this bug was appearing only in portal_factory)
  
2. added FCKLinkWidget : can be used for browsing internal links in place of StringWidget
   when editing fields with urls.
   
3. Fix IE6 error in kss plugin : must call a new var when setting a value for "self".

4. Minor changes : browser params added to FCKLinkWidget (browser_root, browser_path, internal_links_only)

5. Fix alert when saving contents with anchors in urls

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.6 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Fix important problem with browser : browsing parent folders was broken since connector is called from context (bug introduced in 2.4.3)
   This fix also the bug when browsing children with same id.
   
2. improve wysiwyg editor quality and resolve http://plone.org/products/fckeditor/issues/36
   - use documentContent class in editor area (fckconfig.js changed)
   - display the good font size allowing to base properties (69*110/100)% (fck_ploneeditorarea.css replaced by a dtml file)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.5 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------

1. Fix error with Save icon in portal_factory > when a new document is created, we don't try to save in line, just submit the form.
2. Fix error with Save icon in full screen mode (the form was submitted), we force standard screen mode before saving in line.
3. Fix error with base_edit standard form submit, the finalizePublication was not launched (this fix also the "editor.doUpdate" js error on submit).
4. Move Save_inline function from kss_plugin.js to fck_plone.js
5. Fix problem with scanlinks javascript function (Plone 2.5.x) : mark_special_links.js moved at bottom
   in portal_javascripts at FCKeditor.Plone Installation.

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.4 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Plone3 kss implementation finished   
2. Fix pathUSer error when opening browser (important bug fix)
3. makeLinksRelative was broken in some situations
4. Faq item about serverside spellchecker removed
5. fck_ruid_to_url fix : absolute_url() is the most reliable way of getting an object's URL.
   portal_url.getRelativeUrl`` will break in "more interesting" VHM settings (Thanks to nouri)
6. Fix connector bug (http://plone.org/products/fckeditor/issues/34) when PloneArticle was not installed (items were shown in double) 
7. gruiiikkk patch for old gecko fck bug with anchors (http://plone.org/products/fckeditor/issues/5 is fixed)
8  fix bug http://plone.org/products/fckeditor/issues/31 with prefs_fckeditor_member

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.3 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. merge branch reinout-2.4.2fixes with trunk.
   modifications done by Reinout van Rees (Thx) : 
   - resolve 'insecure content' warning in files browser, when browsing a https site with MSIE.
   - added RichDocument compatibility for browsing/uploading,.   
2. fixed PloneArticle 4 thumbs url error (changes in new PAV4 reported here)
3. svn download : the product download is no more necessary
   a svn-externals to fckeditor svn has been added.
   base2zope.py SRC_ROOT changed because fckeditor source directory is changed  (_src/fckeditor)
4. Based on FCKeditor 2.4.3 (many bugfixes - see _whatsnew.html)
5. Added folder_portal_type option in configlet (type used for folder creation in browser)
6. Added RichDocument portal_types in config (todo : add rd_portal_types in configlet)
7. Re-Added UniversalKey as plugin (you must allow it with custom toolbar configuration in configlet)
8. Default Validator added to configlet form (to avoid warning in zope instance logs)
9. Important change : FCKWidget is working fine (see examples in RichContentDemo.py for how to use it)
10. new styles added in menu styles default configuration 
11. remove refresh.txt since refresh is no more possible with zope 3
12. Added toolbar_start_expanded property in config and widget (is set to True in config by default, 
    can be changed only through widget)
13. Changed : standard fck templates replaced by more sexy plone templates.
    See : skins/fckeditorplone/fcktemplates.xml.pt and /fckeditorplone/fcksamples subfolder to build 
    your own templates.
14. Fix french configlet font size with MSIE due to bad i18n msgtr
15. Removed bad "reindex contents" lines in connectorPlone.py and uploadPlone.py.
16. FCKWidget browser improvements (you can set different browsing/uploading params through widget)
17. RichDemoContent sample improvements (a simple ATContent to show how to use widget)
18. makeLinksRelative on submit was broken with FireFox (we use standard FCK event handlers to do the same
    thing)
19. fckeditor.js & fck_plone.js were loaded for each editor instance, this is fixed.
    When using fckwidget the scripts are loaded in html header with widget.helper_js  
20. when updating fckeditor, missing properties are added, some properties
    are updated ("custom toolbar" and "custom keyboard behavior", you can refuse this 
    update with UPDATE_PROPERTIES value in config.py, at you own risk.
21. fix widget bugs with browserValues  (for browser xml connector and uploader)   
22. fix regression on upload (uploading file_portal_type was broken) 
23. fix encoding problems when uploading files through browser

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.2  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Based on FCKeditor 2.4.2 (see _whatsnew.html).
   Important change is the keyboard behavior : CR = <p>...</p>, SHIFT-CR = <br />
2. Resolved bug http://plone.org/products/fckeditor/issues/19 with rtSpellCheckPlugin & Apache in front of Zope
3. Resolved bug http://plone.org/products/fckeditor/issues/17 ("Style" and "Format" drop downs are clipped)
4. fix error with german translation http://plone.org/products/fckeditor/issues/21

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4.1  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Based on FCKeditor 2.4.1 (see _whatsnew.html).
   Important change is the keyboard behavior : CR = <p>...</p>, SHIFT-CR = <br />
2. Change keyboard control default values as set in new fckeditor version
3. Resolve small bug in configlet control panel with visualClear class (http://plone.org/products/fckeditor/issues/9)
4. Added keyboard control fieldset in configlet to easily define keyboard behavior 
  (Enter Mode, Shift Enter Mode, other keystrokes control)
5. remove BOM through base2zope (a known bug on many 2.4.1 html files) : http://sourceforge.net/tracker/index.php?func=detail&aid=1685547&group_id=75348&atid=543653
6. remove some XHTML errors in original product  

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.4  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Based on FCKeditor 2.4 (see _whatsnew.html)
2. Licensed under GPL
3. By default a toolbar with less functions is set for Plone 
  (according to portal_transforms default configuration, font & forms menus are removed)
4. added qPloneResolveUid code (transform resolveuid url in absolute_url) ... thx to Quintagroup
5. fix problem with AT RichWidget default value for cols (this value is set to 40, so we suppose 40 cols = 100%)
   the good choice for your richtext fields is to fix width in px or %
6. New options added, old options removed in fckconfig.js   

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.3.3  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Plone configlet is now easier to use and provides a safer way to customize FCK behaviour in a Plone site.
   - Only compatible content types can be selected for files, images and flash.
   - Added a validator to the configlet such FCK will work (crossing fingers) whatever changed.
2. Fixed : when width was fixed in px through configlet, editor was broken  
3. PloneArticle bontang compliance for browsing/uploading
4. image rapid upload : added size choice
5. removed some plone 2.0 dependencies
6. added "FitWindow" toolbar button to switch in fullscreen mode.

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.3.2 (unreleased))  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Based on FCKeditor 2.3.2 (see _whatsnew.html)
2. Added : rtSplleChecker plugin, client spell checker for Fire Fox 2
3. Fixed : templates replace options added in fckconfig 
  (to prevent user from erasing content before choosing new template)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.3.2  :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Based on FCKeditor 2.3.1 see _whatsnew.html
2. Includes base2zope.py and testTemplates.py based on Chad Whitacre FCKeditor.Zope package.
   For easy update from original fckeditor package : read _zope_help/faq.txt.
3. fckeditor skin layer removed from SVN, launch utils/base2zope.py before installation when using  SVN product  
4. browser uses getFolderContents method (Plone 2.0x compliance is no more supported)
5. You can choose list of portal_types to browse and link images and flash animations
6. Skins silvernarrow and office2003blue removed (since there are not compatibles with FckEditor 2.3)
   It's very simple to add new skins in future with base2zope.py script.
7. When browsing for linking images, 8 sizes are proposed (ATImage standard sizes). 
8. Images preview are thumbnailized in browser(/image_thumb)

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.3.1 (SVN UNRELEASED) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. FCKeditor.Plone is available on Plone Collective svn
2. Based on FCKeditor 2.3 see _whatsnew.html
3. Uses 2 separate plone skins layers :
   fckeditorplone layer for Plone product, 
   fckeditor layer for original product : put modifications only when necessary in this directory (zope Addons, plugins or temporary bug fixes)
4. Accepts multiple css in Editor Area (portal_css entire compliance)
5. Styles combo menu uses Plone2.1 images classes (image-left, image-right, image-inline)
6. PloneArticle based types bug fixed : browser was not opening in article (thx to Thomas Wenger)
7. Editor AutoDetectLanguage = false (problems with LinguaPlone) : now Language is taken from Plone Language settings
8. Error with javascripts inside content fixed
9. Save icon is working (form submit)



------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.2.1 (minor bugs corrections 04/03/06) :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. moz-bindings.xml and moz-bindings.xml.metadata removed from skin
2. compilation error fckpaste.html.pt was not really fixed (thx to jakub Wisniowski and Jean-Charles Rogez) 
3. po files (french translation) thx to JCR
4. Styles corrections in forms - thx to JCR
4. FCK Members preferences form was broken when Members folder creation was turned off in Portal_membership
   thx to JCR
5. fr.js UTF-8 was broken (thx to Marc Aurèle Darche)
6. A deprecated import from CMF in __init__.py removed by MAD
7. Error loading "fckstyles.xml" without Plone fixed (thx to "vox" on http://macadames.com)
8. Error with customized portal_types based on PloneArticle in browser fixed
9. Added : we can choose thumbs when browsing PloneArticle images
10. CPS examples :
    to make browsing and all toolbars available you can test 
    cpsdocument_edit_form and popup_rte_form examples (look at folder CPS_examples);
    Many errors fixed in connectorCPS.py, always some tips to add and bugs to fix (don't refresh after upload)
11. new toolbars skins added (silvernarrow and office2003blue)  

------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.2 (Plone/CMF integration) 11/02/06 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. FCK.Plone uses FCKeditor 2.2 : see _whatnew.html
2. By default Gecko browsers use span tags in place of font tags
   when choosing font family, color and background color (not available for MSIE)
   for better xhtml strict, and plone2.1.x VALID_TAGS compliance.
3. h1 removed from font format menu (you can personalize this menu through  fckconfigPlone.js.dtml)
4. ToolBar customization added to plone control panel 
5. fckAbsUrl and fckCreateValidZopeId in utils.py no more called as contextual methods
   just call modules/Products.FCKeditor.utils/... when necessary (thx to Marc Aurèle Darche)
6. Import from CMF don't use deprecated aliases (thx to MAD)
7. Editor width/height accept px, %, or 'no units'. 
   With standard plone ATCT, by default the width is set to 100%
8. You can force editor width/ height through plone control panel.
   This option is not recommanded when using your own AT content types.
   A better solution is to fix width and height through the visual or richtext widget (more flexibility when ATCT have multiple wysiwyg fields)
   When setting this option widget width and height are not active.
9. htc files renamed in htc.dtml for zope skin integration
10. compilation error moz-bindings.xml fixed (fckeditor original code source  bug fixed)
11. compilation error fckpaste.html.pt fixed (fckeditor original code source bug fixed) 
12. GetHTML replaced by GetXHTML in fck_plone.js.dtml to make function
   'makeLinksRelative' working with FCKeditor 2.2
13. You can set your specific Content Types based on PloneArticle through Control Panel:
    List of PloneArticle meta_types for browsing/uploading attachements and images.
14. Content Sizes are well formatted in browser

     


------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.1.1PR3 (Plone/CMF integration) 22/01/06 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Many bugs fixed after FCKeditor.Plone 2.1.1 PR2 (see http://macadames.com/forum)
2. parsing url error with folderish fixed
3. ATCT text_format selector error fixed (the field is no more disabled)
4. Fixed : Path error when browsing new content created with portal_factory (standard plone 2.1)
5. Fixed : Plone Article basehref and makeLinksRelative problem
6. Fixed : utf-8 encoding problems in browser
7. Added sarissa.js in package for plone2.0 platforms 






------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.1.1PR1 (Plone/CMF integration) 31/10/05 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. FCKeditor.Plone 2.1.1  is based on FCKeditor 2.1.1 
   All editor changes are notified in _whatsnew.html
2. Added fck Plone control panel with many features
3. Added fck Plone member preferences
4. connectorCPS.py and popup_rte_form.pt (in _zope_help/CPS) for advanced CPS browsing implementation (many thanks to Youenn Boussard alias youyou on macadames.com)
5. popup_rte_form.pt moved from skin because new CPS version is using FCKeditor as default wysiwyg editor
   when the product is installed (http://svn.nuxeo.org/trac/pub/ticket/502 thx to Marc Aurèle Darche).
   If you want to use new browser capabilities you could write your own wysiwyg template (see CPS example)
6. Correction bug : http://macadames.com/forum/46734164462 (BASE0 replaced by SERVER_URL on many files)
7. Changed some "</" in "<\/" from fckeditor original code (fck_paste.html)
8. Added specific zope functions to rapid upload (fck_link.html.pt, fck_image.html.pt, fck_flash.html.pt)
9. All html editor files changed in pages templates (not tested with Zope < 2.7.2)
10. changed : status 301 for resolveUid redirection
11. added : makeLinksRelative before posting to server (you can desactivate it through plone control panel)
    this code is taken from kupu (thanks)



------------------------------------------------------------------------------------------------------------------------------------------------------------------------
Changes in FCK.Plone 2.0.2 (Plone/CMF integration) 04/10/05 :
------------------------------------------------------------------------------------------------------------------------------------------------------------------------
1. Fast upload Plone implementation (you can upload without browsing in Folder choosed as Current Folder for edition - by default, the current folder)
   you can disable it in fckeditor_wysiwyg_support.
2. Plone Article V2 and V3  compatibility for browsing /uploading attachements and images. A very powerful feature.
3. Album presentation in browser when browsing for images. Very useful feature.
4. Correction bug SF[ 1288479 ] (FCKeditor.Plone 2.0.1 url problem + patch)
5. Correction bug fck_paste.html (many '</' in javascript strings)
6. When editing a folderish type or a Plone Article type, the path for browsing and fast upload is the folder (or PA) itself.
   (see bug SF[1215798] which is not really a bug, just a feature request)
   The folder (or PA) need to be pre-published (test on here/Title),
   otherwise, the parent folder is choosed as path.
7. Correction bug : path for browsing/uploading when editing folderish types in Plone 2.1
8. More documentation
6. CMF Photo Album / CMF Photo compatibility for browsing/uploading photos (as we did it for ZPhotoSlides, the best Plone photo album product)
9. Correction bug when referencing an url by UID : when a content didn't have an UID but a parent container did it,
   the browser was referencing the first parent with UID (there is the same bug in Kupu 1.3rc3).
   We changed "if hasattr(objekt, UID)" in "if hasattr(objekt.aq_explicit, UID)"
   The best method in Plone2.1 could be  "if IReferenceable.isImplementedBy(objekt)", not yet implemented
10. Many javasript corrections in browser.
11. Charset and Unicode corrections when posting files and images through rapid upload or through the browser
    The browser and rapid upload function was fully tested with UTF-8 and ISO-8859 Plone sites, 
    but encoding is really complicated, so conflicts are always possible (submit bugs to FCKeditor tracker ... )
13. Correction bug when ATCT are using "width=100%" in richtext widgets
14. PloneArticle V3 attachements are referenced by UID
15. Many bug corrections in browser xml connector and upload script
16. Can preview files and images in browser before linking
17. Correction bug charset on create folders 
18. Correction bug when image titles were using quotes in browser view
19. Correction bug with plone article v2 attachements (problem with ids and url in utf-8 plone site)


Changes in FCK.Plone 2.0.1 (Plone/CMF integration) 05/09/05 :

1. FCKeditor.Plone 2.0.1  is based on FCKeditor 2.0
2. Added examples for Plone (in this directory) : ArcheTypes Widgets for browsing internal links, and richtext editing
   a link_edit_form template to import (it's just an example of Customization don't use it in Plone 2.1, neither in production environnement)
3. skin directory is renamed from "editor_fck" to "fckeditor" for cohabitation with others editors (Kupu, Epoz, ...)
4. Changed : intall.py :
   - site properties > available_editors attribute changed from 'FCK Editor' to 'FCKeditor' for multiple editors cohabitation
5. Added an extension to update members wysiwyg_editor property in portal_membership
   for users who were using a previous version (updateFckUsers.py)
6. Plone connector adapted for Flash and Media files browsing;
   Note : Today content type for Flash and Media is "File", and we cannot select between file extensions in Zope/Plone
   because extension is not significant. 
   So when browsing for Flash or Medias files, all files are shown ... Solution could be a specific Content Type for Flash content
7. Always some corrections for '</' bug in javascript fck source code.
8. Added fckAbsUrl method for editing because FCK editor need absolute url, now relative url are parsed and relative image urls are well shown in editor area.
   If you want to retrieve relative urls after the publication you need to install an EpozPostTidy external method provided in the package (more info on Epoz site)
9. Added in browser the possibility to reference ATCT url as UID (adapted from Kupu - many thx to everybody),
   if you want to disable it just change the parameter linkbyuid=1 to 0 in ploneConnector.py
10.wysiwyg_support.pt fckeditor_wysiwyg_support.pt and mini_wysiwyg_support.pt adapted for 
   new Url referencing system and kupu/Epoz cohabitation
11.when uploading files and images through the browser you can set a title - images titles are used to set the "alt" property when choosing them.
12.When browsing you can link a folder or another collection, by default url are referenced by UID
13 Fully tested with Plone 2.1, everything seems ok.
14.added : refresh.txt (it's not always a good idea to refresh the product, in production site it's better to restart Zope)



Others corrections before next release - June 2005
1. corrections spellerchecker.html - "</p>" changed in "<\/p>" line 54
   FCK original code need to be changed in valid XHTML for stopping that bug and changing all .html.html in .html.pt
2. some changes in fckconfig.js (SmallZopeCmf toolbar comes now with styles combo menu - ZopeCmf toolbar comes with "SpellCheck" button)
3. fckstyles.xml.pt customized for styles combo
   look at editor/css/fck_ploneArea.css, there are some css classes to  add in your plone.css (or ploneCustom.css)


Corrections FCKeditor.Plone 2.0.1 FC - patch p1 - thx to madduck
1. Corrections on connectorPlone.py for some XML 503 error (thx to madduck)
2. Corrections for some XML syntax errors
3. security tips : now browser don't show Zope folderish CT which are not portal content types
4. wysywig templates honour Archetypes size widget argument :
   IMPORTANT : take care if you were using previous FCKeditor version with your Archetypes Content types 

Changes in FCKeditor.Plone 2.0.1 FC 19/05/05 :
changed : wysiwyg_support and mini_wysiwyg_support for better FCK http cache perfomance
          these new templates correct a small bogue with some plone sites .
 

Changes in FCK 2.0 FC for Plone/CMF integration 16/05/05 :

1. Plone.FCKeditor 2.0 FC  is based on FCKeditor 2.0 FC
2. added : specific Zope Browser based on FCK standard Browser with Zope Objects browsing
           Object attributes for xml nodes (title, description, image attributes for CMF Photo and Zphotoslides ...)

3. added : specific Plone connector (upload functions enabled - upload zphotoslides enabled ...)
           This connector is not CPS compatible but it's easy to transform
4. FCKConfig.Basepath is defined in wysiwyg_support for Plone, in rtepopup for CPS
5. New Browser Url is defined in wysiwyg_support templates for Plone
6. Rename fcktemplates.xml in fcktemplates.xml.pt for Zope compatibility
7. Rename all xml files in xml.pt
8. change all '/' in javascript strings for '\/' for xhtml and zpt compatibility - always the same problem ... Fred

Changes in Zope Package 03/04/05

1. added : CPS compatibility
2. added : FCK HHTP Cache for better compatibility with others Zope 2.xx based CMS
3. added : ZPT example for CPS integration (popup_rte_form.pt)


Changes in FCK 2.0 FC-Preview for Plone/CMF integration :


1. The folder skins is renamed fck_skins because 'skins' is reserved in Zope CMF

2. Change file fckconfig.js  (line 29 for skinPath)

3. Change fonts in fckconfig.js 

4. Change all files in ".html" as ".html.html" ".html.pt" would be better but the editor source code is not XHTML compatible (happily it produces XHTML) .

5. Added wysiwyg_support files (CMF template) for CMF integration

6. Added CMF/plone installation files at product root

7. Move all files in folder skins/editor_fck/ for CMF product integration

8. Added default basepath in fckconfig.js

9. Customization of toolbars in fckconfig.js

10. Added link to BrowseLink and BrowseImage in fckconfig.js

11. Added dtml and scripts python for browseLinks and BrowseImages

12. Rename fckstyles.xml in fckstyles.xml.pt for Zope compatibility

13. Added a .metadata file for each file (for Plone HttpCache) 

14. Since Zope 2.7.2 Zope doesn't accept anymore "</" in javascript strings inside html files, for example we must change '</div>' in '<\/div>' 
    > please Frederico can you change these files

Details : files and lines with corrections on </ bug in javascript strings
editor/fckdialog.html 40
editor/fckdebug.html 38 46 78
editor/dialog/fck_anchor.html  57
editor/dialog/fck_specialchar.html  76 81 85 86 89
editor/dialog/fck_smiley.html  70 76 77 80 81 84
editor/dialog/fck_about.html  119
editor/dialog/fck_spellerpages/spellchecker.html  many lines
editor/dialog/fck_template.html  many lines
editor/dialog/fck_paste.html many lines

